/*
 * reducer.c source file for extace
 * 
 /GDK/GNOME sound (esd) system output display program
 * 
 * Copyright (C) 1998 by Michael Fullbright
 * Re-hacked to look good by The Rasterman
 * 
 * Hacked some more by Dave J. Andruczyk <dave@techdev.buffalostate.edu>
 * to be fully scalable with lots of new options, for tilting the axis's
 * and various other cool stuff.
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You may use this program at your own risk.
 */

#include <config.h>
#include <globals.h>
#include <protos.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


// See globals.h for variable declarations and DEFINES


void reducer(float spikes_per_pip,int x_travel)
{
    gint i,j;
    gfloat pip;
    gfloat running_total;
    gfloat pip_total;
    gfloat partial;
    gint special_case;

    i = 0;
    j = 0;
    pip = spikes_per_pip;
    running_total = 0.0;
    special_case = 0;
    pip_total = 0;
    partial = 0.0;
    while (i < x_travel)
    {
	while (pip > 1.0)
	{
	    pip_total += disp_val[j]*1.0;
	    pip--;
	    j++;
	}
	if ((pip < 1.0)  && (spikes_per_pip > 1.0))
	{
	    pip_total += disp_val[j]*pip;
	    pip_arr[i] = (gint)(pip_total/spikes_per_pip);

	    pip_total = disp_val[j]*(1.0-pip);
	    pip = spikes_per_pip - (1.0 -pip);
	    j++;
	    i++;
	}
	if (spikes_per_pip == 0.5)
	{
	    pip_arr[i] = (gint)disp_val[j]*0.5;
	    i++;
	    if(i%2)
		j++;

	}
	if (spikes_per_pip < 1.0 )
	{
	    if (running_total + pip > 1)
	    {
		partial = 1 - running_total;
		special_case = 1;
	    }
	    running_total += pip;
	    if (special_case)
	    {
		pip_total = disp_val[j]*partial;
		j++;
		pip_total += disp_val[j]*(running_total - 1.0);
		special_case = 0;
	    }
	    else
	    {
		pip_total += disp_val[j]*pip;
	    }
	    if (running_total >= 1.0)
	    {
		running_total -= 1.0;
	    }

	    pip_arr[i] = (gint)(pip_total/spikes_per_pip);
	    i++;
	    pip_total = 0;

	}

    }
}
